#include "stdafx.h"
#include "resource.h"
#include "publicctrl.h"
#include "cpss_dialog.h"
#include <stdio.h>
#include "CN828_Board.h"

 
#define  Y_GAP 8
#define  X_MARGIN 32
#define  Y_MARGIN 28
#define  HEIGHT_DEFAULT 44
#define  HEIGHT_BUTTON_WIDTH 80
#define GAP_DEFAULT 24
#define  EDIT_BORDER 4 //5
#define EDIT_EXTRA_HEIGHT 4

#ifdef UNDER_CE
#define DIAG_PATH "\\DATAoverIP\\OUT\\config.dat"
#define REQ_PATH "\\DATAoverIP\\OUT\\boardcomp.dat"
#define DIAG_IN_PATH "\\DATAoverIP\\IN"
#else
#define REQ_PATH "d:\\tmp\\boardcomp.dat"
#define DIAG_PATH "d:\\tmp\\config.dat"
#define DIAG_IN_PATH "d:\\tmp"
#endif
typedef struct {
	UINT nID; // str ID , -1 is direct string
	char  pstr[16]; // used when nID==-1
	RECT rt;//UINT  valine;
}  DISPLAY_CELL;

 #define m_btnlist m_Btns
 #define m_btAct (&m_Btns[1])



static DWORD WINAPI CommandTask(void*para );
inline BOOL __get_time__(FILETIME* ftime)
{
	SYSTEMTIME systm;
	GetSystemTime(&systm);
	return SystemTimeToFileTime(&systm,ftime);
}
static DISPLAY_CELL   gTitle[] = {  
	{IDS_BOARD_OVERALL,{0},{161,60, 150,ROW_H}},{IDS_BOARD_LAST_STOP,{0},{360,60, 150,ROW_H}},{IDS_BOARD_LAST_RESET,{0},{562,60, 150,ROW_H}},	
	{IDS_BOARD_MAX,{0},{161,326, 150,ROW_H}},{IDS_BOARD_AVERAGE,{0},{360,326, 150,ROW_H}},

	{IDS_BOARD_DRIVING,{0}, {25,118, 150,ROW_H}}, 
	{IDS_BOARD_STANDING,{0},{25,197, 150,ROW_H}}, 
	{IDS_BOARD_DIST,{0},	 {25,275, 150,ROW_H}},
	{IDS_BOARD_SPEED,{0},	 {25,377, 150,ROW_H}}
};
 
static DISPLAY_CELL   display_cell[]={
	 
	{0,{0},{161,118, 150,ROW_H}},	{0,{0},{361,118, 150,ROW_H}} ,	{0,{0},{562,118, 200,ROW_H}},
	{0,{0},{161,197, 150,ROW_H}},	{0,{0},{361,197, 150,ROW_H}},	{0,{0},{562,197, 200,ROW_H}},
	{0,{0},{161,275, 150,ROW_H}},	{0,{0},{361,275, 150,ROW_H}},	{0,{0},{562,275, 200,ROW_H}},
	{0,{0},{161,377, 150,ROW_H}},	{0,{0},{361,377, 150,ROW_H}}	 
};
static HWND g_hWnd=NULL;
void zeit_callback(unsigned char* buf,HWND hWnd)
{
	DWORD dw;
	if(buf==NULL) return;
	if(6 ==buf[0])
	{
		if(buf[1]==1) {
			if(LongInvalid((&buf[6]))) strcpy(display_cell[0].pstr,"---");
			else{
				BY2DW(dw,&buf[6]);
				sprintf(display_cell[0].pstr,"%02d:%02d", dw/60,dw%60);
			}
			if(LongInvalid((&buf[14]))) strcpy(display_cell[1].pstr,"---");
			else{
				BY2DW(dw,&buf[14]);
				sprintf(display_cell[1].pstr,"%02d:%02d", dw/60,dw%60);
			}
			if(LongInvalid((&buf[2]))) strcpy(display_cell[3].pstr,"---");
			else{
				BY2DW(dw,&buf[2]);
				sprintf(display_cell[3].pstr,"%02d:%02d", dw/60,dw%60);
			}
			if(LongInvalid((&buf[10]))) strcpy(display_cell[4].pstr,"---");
			else{
				BY2DW(dw,&buf[10]);
				sprintf(display_cell[4].pstr,"%02d:%02d", dw/60,dw%60);
			}
			 

		}else if(buf[1]==3) {
			if(LongInvalid((&buf[2]))) strcpy(display_cell[8].pstr,"---");
			else{
				BY2DW(dw,&buf[2]);
				sprintf(display_cell[8].pstr,"%.2f km", dw*0.01);
			}
			if(ShortInvalid((&buf[6]))) strcpy(display_cell[9].pstr,"---");
			else{
				BY2HW(dw,&buf[6]);
				sprintf(display_cell[9].pstr,"%.1f km/h", dw*0.1);
			}
			if(ShortInvalid((&buf[8]))) strcpy(display_cell[10].pstr,"---");
			else{
				BY2HW(dw,&buf[8]);
				sprintf(display_cell[10].pstr,"%.1f km/h", dw*0.1);
			}
		}
		else if(buf[1]==2){
			if(LongInvalid((&buf[2]))) strcpy(display_cell[5].pstr,"---");
			else{
				BY2DW(dw,&buf[2]);
				sprintf(display_cell[5].pstr,"%02d:%02d", dw/60,dw%60);//2
			}
			if(LongInvalid((&buf[6]))) strcpy(display_cell[2].pstr,"---");
			else{
				BY2DW(dw,&buf[6]);
				sprintf(display_cell[2].pstr,"%02d:%02d", dw/60,dw%60);  //5
			}
			if(LongInvalid((&buf[10]))) strcpy(display_cell[6].pstr,"---");
			else{
				BY2DW(dw,&buf[10]);
				sprintf(display_cell[6].pstr,"%.2f km", dw*0.01);
			}
			if(LongInvalid((&buf[14]))) strcpy(display_cell[7].pstr,"---");
			else{
				BY2DW(dw,&buf[14]);
				sprintf(display_cell[7].pstr,"%.2f km", dw*0.01);
			}
		}
	}
	if(g_hWnd!=NULL && IsWindow(g_hWnd))
	{
		InvalidateRect(g_hWnd,NULL,TRUE);
		UpdateWindow(g_hWnd);
	}
}

static const BUTTON_ITEM Button_EngInfo[] = 
{
	//{ 416, 121,	44,	    44,ID_BACKSPACE ,IDB_BACKSPACE    ,IDB_BACKSPACE_DN },  //For Name
	//{ 416, 165,	44,	    44,ID_UPICON    ,IDB_UPICON       ,IDB_UPICON_DN},
	{ Btn_CancelX, Btn_CancelY,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL,IDBI_CANCEL_DN},

};

static  const BUTTON_ITEMEX Button1_EngInfo[] = 
{
	//{ 416, 121,	44,	    44,ID_BACKSPACE ,IDB_BACKSPACE    ,IDB_BACKSPACE_DN },  //For Name
	//{ 416, 165,	44,	    44,ID_UPICON    ,IDB_UPICON       ,IDB_UPICON_DN},
	{ 560 , 370,	HEIGHT_BUTTON_WIDTH , 43,ID_BUTTON_RESET,IDB_BDCOMP_BUTTON_RESET , IDB_BDCOMP_BUTTON_RESET_DN,   0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL},
	//{ X_MARGIN+120, 84,	HEIGHT_BUTTON_WIDTH , 43,ID_BUTTON_2,IDB_BUTTON_121x43 , IDB_BUTTON_121x43_DN,   0,0,110,40,TitleFontWide,TitleFontHeight,15},
    //{ 327,	        20,	HEIGHT_BUTTON_WIDTH,  43,ID_VU_HELP ,IDB_BUTTON_121x43,	 IDB_BUTTON_121x43_DN,	0,0,110,40,TitleFontWide,TitleFontHeight,15},     //Send Msg Send 
};
//extern cCPSSFileInfo CpssFile;



LRESULT CN828VUBoard::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 t55_get_zeit();
	for(int count=0; count<sizeof(Button_EngInfo)/sizeof(BUTTON_ITEM) ; count++)
	{
		CREATE_BTN_TRANS2(m_btnlist[count], m_nIDBACK, Button_EngInfo[count]);
	}

	RECT rect;
	rect = Button1_EngInfo[0].rt;
	
	 
	for(DWORD count=0; count<sizeof(Button1_EngInfo)/sizeof(BUTTON_ITEMEX) ; count++)
	{
		BOOL bEnable = true;
		
		CString str;
		str.LoadString(Button1_EngInfo[count].uId );
		CREATE_BTN_TRANS(m_btAct[count], m_nIDBACK,str,Button1_EngInfo[count]);
		
	}	
	g_hWnd = m_hWnd;
	SetTimer(1,5000,NULL);
	VButtonWnd::OnInitDialog(uMsg, wParam, lParam, bHandled) ;
    return 0;  
}


void CN828VUBoard::OnPaintExt(HDC hDC,CRect& rcPaint)
{
	DrawDC Draw(hDC);
	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(255, 255, 255));
	CRect rect;
	HFONT hOldFont = Draw.SetFont(m_hBigFont);
	CString str;
	int cols = sizeof(gTitle)/sizeof(DISPLAY_CELL);
	int i;
#ifdef __NEW_BK__
	for(i=0;i<cols;i++)
	{
		str.LoadString(gTitle[i].nID);
		rect.left= gTitle[i].rt.left;rect.top=  gTitle[i].rt.top;
		rect.right= rect.left+gTitle[i].rt.right;rect.bottom= rect.top+gTitle[i].rt.bottom;
		Draw.DrawStringRect((LPTSTR)(LPCTSTR)str,&rect,DT_CENTER|DT_VCENTER);
	}
#endif
	cols = sizeof(display_cell)/sizeof(DISPLAY_CELL);  
	for(i=0;i<cols;i++)
	{
		rect.left= display_cell[i].rt.left;rect.top= display_cell[i].rt.top;
		rect.right= rect.left+display_cell[i].rt.right;rect.bottom= rect.top+display_cell[i].rt.bottom;
		//Draw.DrawFillRoundRect(&rect,BORDER_CLR,FILL_CLR,BORDER_W,CORNER_W,CORNER_W);	
#ifdef __NEW_BK__
		Draw.DrawNewRect2(&rect,TRUE,TRUE,FILL_CLR);
#endif
		Draw.DrawStringRect(convert_val(display_cell[i].pstr) ,&rect,DT_CENTER|DT_VCENTER);
		 
	}

	
	Draw.SetFont(hOldFont);
	 
}
 
LRESULT CN828VUBoard::OnButton1(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	 

	BUTTON_ITEM Button_bmp[] = 
	{
		{ Btn_CancelX-1, Btn_CancelY+1,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL,IDBI_CANCEL_DN},
		{0,0,0,0,0,0,0}
	};

	BUTTON_ITEMEX Button_txt[] = 
	{
		{ 560 , 371,	HEIGHT_BUTTON_WIDTH , 43,ID_BUTTON_RESET,IDB_BDCOMP_BUTTON_RESET , IDB_BDCOMP_BUTTON_RESET_DN,   0,0,0,0,TitleFontWide,TitleFontHeight,15},
		{0,0,0,0,0,0,0}
	};


	CpssMsgDlg dlg(IDB_BDCOMP_RESET,NULL,0);
	dlg.m_BmpButtonTmpl = Button_bmp;// Button_Cancel;
	dlg.m_TxtButtonTmpl = Button_txt ;
	if( dlg.DoModal() )
	{
		
	    PlaySound(IDR_WAVE,FALSE);
	/*	FILE *f = fopen(DIAG_PATH,"wt");
		char * szCmd = "1\nGPS+BORDRESET" ;
		if(f){
			fwrite(szCmd,1,strlen(szCmd),f);
			fclose(f);
		}*/
		for(int j=0;j<sizeof(display_cell)/sizeof(DISPLAY_CELL);j++)
		{
			display_cell[j].pstr[0]=0;
		}
		t55_reset_zeit();
	}
	 
	
  return 0;
}
LRESULT CN828VUBoard::OnButton2(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
/*	FILE *f = fopen(REQ_PATH,"wt");
	char * szCmd = "1" ;
	if(f){
		fwrite(szCmd,1,strlen(szCmd),f);
		fclose(f);
	}
  */return 0;
}


LRESULT CN828VUBoard::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	//SetEvent(ghExitEvent);
	//if(	g_hCommandThread ) WaitForSingleObject(g_hCommandThread,TIMEOUT_COMMAND); g_hCommandThread=0;
	__restore_pre_window_handle__(m_hWnd);
	g_hWnd = NULL;
	//CloseHandle(ghExitEvent);
	EndDialog(1);
	//PostQuitMessage(0);
	
	return 0;
}



LRESULT CN828VUBoard::OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	BOOL bHandled;
	OnButton2(0,0,0, bHandled);
	return 0;
}






 
LRESULT CN828VUBoard::OnUserIndicate(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 
  

	return 0;
}
